(function() {
	'use strict';

	angular.module('ipconfigure.orchid.core').filter('bytes', [bytesFilter]);

	function bytesFilter() {
		// modified from https://gist.github.com/thomseddon/3511330
		return function(bytes, precision, forcePrecision) {
			var baseMultiplier = 1024,
				units = ['bytes', 'KiB', 'MiB', 'GiB', 'TiB', 'PiB', 'EiB', 'ZiB', 'YiB'],
				parsedBytes = parseFloat(bytes),
				unitFactor,
				val,
				result;

			if (isNaN(parsedBytes) || !isFinite(parsedBytes) || parsedBytes < 0) {
				result = '-';
			}
			else if (parsedBytes === 0) {
				result = '0 bytes';
			}
			else {
				if (typeof precision === 'undefined') {
					precision = 1;
				}

				unitFactor = Math.floor(Math.log(parsedBytes) / Math.log(baseMultiplier));
				val = (parsedBytes / Math.pow(baseMultiplier, Math.floor(unitFactor))).toFixed(precision);
				result = (forcePrecision ? val : parseFloat(val)) + ' ' + units[unitFactor];
			}

			return result;
		};
	}
}());
