(function() {
	'use strict';

	angular.module('ipconfigure.orchid').controller('PrerequisiteFbgstCtrl', ['$scope', '$rootScope', '$timeout', PrerequisiteFbgstCtrl]);

	function PrerequisiteFbgstCtrl($scope, $rootScope, $timeout) {
		var fbgst = document.getElementById('fbgst'),
			checkFbgstTimer;

		$scope.requiredFbgstVersion = window.requiredFbgstVersion;

		(function checkFbgst() {
			if (fbgst === null || typeof fbgst.version === 'undefined') {
				document.getElementById('current').textContent = 'You currently do not have FBGST installed or we do not have permission to execute it.';

				checkFbgstTimer = $timeout(checkFbgst, 500);
			}
			else {
				document.getElementById('current').textContent = 'You currently have v' + fbgst.version;

				// when FBGST is installed and or enabled, send them back to the login page
				if (ipConfigure.core.compareVersions(fbgst.version, $scope.requiredFbgstVersion) === true) {
					$rootScope.$broadcast('prerequisiteSatisfied');
				}
				else {
					checkFbgstTimer = $timeout(checkFbgst, 500);
				}
			}
		}());

		$scope.$on('$destroy', function() {
			if (checkFbgstTimer) {
				$timeout.cancel(checkFbgstTimer);
			}
		});
	}
}());
