(function() {
	'use strict';

	angular.module('ipconfigure.orchid')
		.controller('StreamPreviewCtrl', ['$scope', '$uibModalInstance', '$rootScope', 'LowBandwidthStreamService', 'AuthService', 'stream', StreamPreviewCtrl]);

	function StreamPreviewCtrl($scope, $uibModalInstance, $rootScope, LowBandwidthStreamService, AuthService, stream) {
		// TODO not right at all, but the <player> directive is overkill and we have no simple <video> directive yet
		var video,
			destroyed = false,
			cachedLowBandwidthStream;

		setTimeout(function() {
			if (destroyed === false) {
				video = new ($rootScope.compatibilityMode ? ipConfigure.components.videoCompatibility : ipConfigure.components.video)('stream-preview', {
					authentication: {
						username: 'sessionId',
						password: AuthService.getAuthenticatedUser().sessionId
					},
					getTime: function() {
						return Date.now();
					},
					stream: stream,
					requestBaseUrl: function(options, callback) {
						// ask low-bandwidth service for a frame puller thing
						LowBandwidthStreamService.createStream(stream, options, function(success, resource) {
							if (success === true) {
								cachedLowBandwidthStream = resource;
								callback(resource.href + '/frame', resource.fps);
							}
							else {
								callback(false);
							}
						});
					},
					onError: 'this.src=\'img/spinner.gif\''
				});

				video.playLive();
			}
		}, 250);

		$scope.$on('$destroy', function() {
			if (video) {
				video.stop();
			}

			if (cachedLowBandwidthStream) {
				LowBandwidthStreamService.destroyStream(cachedLowBandwidthStream);
			}

			destroyed = true;
		});

		$scope.cancel = function() {
			$uibModalInstance.dismiss('cancel');
		};
	}
}());
