(function() {
	'use strict';

	angular.module('ipconfigure.orchid.directive').directive('clickOff', ['$parse', '$document', clickOff]);
	function clickOff($parse, $document) {
		return {
			compile: function($element, attr) {
				// Parse the expression to be executed
				// whenever someone clicks _off_ this element.
				var fn = $parse(attr["clickOff"]);
				return function(scope, element, attr) {
					// add a click handler to the element that
					// stops the event propagation.
					element.bind("click touchmove touchend", function(event) {
						event.stopPropagation();
					});
					angular.element($document[0].body).bind("click touchmove touchend",
						function(event) {
							scope.$apply(function() {
								fn(scope, {$event:event});
							});
						});
				};
			}
		};
	}
}());
