(function() {
	'use strict';

	angular.module('ipconfigure.orchid.directive').directive('fixAwfulAppleProducts', ['$timeout', fixAwfulAppleProducts]);

	function fixAwfulAppleProducts($timeout) {
		return {
			restrict: 'A',
			link: function(scope, wrappedElement, attrs) {
				var element = wrappedElement[0],
					browser = ipConfigure.core.getBrowser();

				switch (attrs.fixAwfulAppleProducts) {
					case 'admin':
						if (browser.platform.toLowerCase() === 'ipad' || browser.platform.toLowerCase() === 'iphone') {
							// force the height, because ipad apparently can't calc on vh very well
							document.querySelector('#admin .camera-list-container').style.height = '200px';
						}
						break;

					case 'config-link':
						if (browser.platform.toLowerCase() === 'ipad' || browser.platform.toLowerCase() === 'iphone') {
							// remove all dem clicks
							wrappedElement.unbind('click');

							// bind our own, because apparently d3 drag events prevent content from scrolling on ipad
							wrappedElement.bind('click', function() {
								window.open('/configuration.html');
							});
						}
						break;
					case 'img-src':
						if (browser.name === 'Safari') {
							// reset the width on an image when the src dynamically changes because safari apparently can't handle fixing the height itself
							// http://www.quirksmode.org/bugreports/archives/2005/03/Safari_Image_src_swap_resize_bug.html
							attrs.$observe('src', function() {
								$timeout(function() {
									element.style.width = (element.clientWidth + 1) + 'px';
									element.style.width = (element.clientWidth - 1) + 'px';
								});
							});
						}
						break;
				}
			}
		};
	}
}());
