(function() {
	'use strict';

	// TODO these don't really need to exist because of CSS transitions

	angular.module('ipconfigure.orchid.directive')
		.directive('minMaxHeightToggler', [minMaxHeightToggler])
		.directive('minMaxWidthToggler', [minMaxWidthToggler]);

	function minMaxHeightToggler() {
		return {
			restrict: 'A',
			scope: {
				minMaxHeightToggler: '='
			},
			link: function(scope, element) {
				var styles = window.getComputedStyle(element[0], ''),
					maxHeight = styles.getPropertyValue('max-height'),
					minHeight = styles.getPropertyValue('min-height');

				scope.$watch('minMaxHeightToggler', function() {
					// using cached values will prevent clients from dynamically changing
					// min/max height.. but.. why would anyone do that?
					element[0].style.height = (scope.minMaxHeightToggler) ? maxHeight : minHeight;
				});
			}
		};
	}

	function minMaxWidthToggler() {
		return {
			restrict: 'A',
			scope: {
				minMaxWidthToggler: '='
			},
			link: function(scope, element) {
				var styles = window.getComputedStyle(element[0], ''),
					maxWidth = styles.getPropertyValue('max-width'),
					minWidth = styles.getPropertyValue('min-with');

				scope.$watch('minMaxWidthToggler', function() {
					// using cached values will prevent clients from dynamically changing
					// min/max width.. but.. why would anyone do that?
					element[0].style.width = (scope.minMaxWidthToggler) ? maxWidth : minWidth;
				});
			}
		};
	}
}());
