(function() {
	'use strict';

	angular.module('ipconfigure.orchid.directive').directive('progressbarThreshold', ['$timeout', progressbarThreshold]);

	function progressbarThreshold($timeout) {
		return {
			restrict: 'A',
			link: function(scope, wrappedElement, attrs) {
				var element = wrappedElement[0],
					thresholdElement = document.createElement('div');

				// $timeout here because <bar>s inside of <progress> delete our custom element otherwise
				$timeout(function() {
					element.style.position = 'relative';

					thresholdElement.classList.add('progressbar-threshold');

					element.appendChild(thresholdElement, element.firstElementChild);
				});

				scope.$watch(attrs.progressbarThreshold, function(thresholdPercentage) {
					thresholdElement.style.left = thresholdPercentage + '%';
					thresholdElement.style.opacity = thresholdPercentage === 0 ? '0' : '1';
				});
			}
		};
	}
}());
