(function() {
	'use strict';

	angular.module('ipconfigure.orchid.directive').directive('shadow', [shadow]);

	function shadow() {
		return {
			restrict: 'A',
			scope: true,
			link: function(scope, element, attrs) {
				var original;

				scope.$watch(attrs.shadow, function() {
					original = scope.$parent[attrs.shadow];
					scope.shadow = angular.copy(original);
				});

				scope.shadowRollbackFn = function() {
					scope.shadow = angular.copy(original);
				};

				scope.shadowCommitFn = function(options) {
					var key;

					if (angular.isUndefined(options) === true) {
						options = {};
					}

					if (Array.isArray(options.ignore) === false) {
						options.ignore = [];
					}

					for (key in scope.shadow) {
						if (scope.shadow.hasOwnProperty(key) === true && options.ignore.indexOf(key) === -1) {
							original[key] = scope.shadow[key];
						}
					}
				};
			}
		};
	}
}());
